## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.9

Main Page | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members | Related Pages

# XalanDOMStringAllocator Class Reference

Collaboration diagram for XalanDOMStringAllocator:

[legend]
List of all members.

## Public Types

- typedef XalanDOMString data_type
- typedef data_type::size_type data_type_size_type
- typedef ArenaAllocator< data_type > ArenaAllocatorType
- typedef ArenaAllocatorType::size_type size_type
- enum { eDefaultBlockSize = 32 }

## Public Member Functions

- XalanDOMStringAllocator (MemoryManagerType &theManager, size_type theBlockCount)
    Construct an instance that will allocate in blocks of the specified size.
- ~XalanDOMStringAllocator ()
- data_type * create ()
    Create a XalanDOMString object.
- data_type * create (const char *theString, data_type_size_type theCount=data_type_size_type(data_type::npos))
    Create a XalanDOMString object.
- data_type * create (const data_type &theSource, data_type_size_type theStartPosition=0, data_type_size_type theCount=data_type_size_type(data_type::npos))
    Copy constructor.
- data_type * create (const XalanDOMChar *theString, data_type_size_type theCount=data_type_size_type(data_type::npos))
    Create a XalanDOMString object.
- data_type * create (data_type_size_type theCount, XalanDOMChar theChar)
    Create a XalanDOMString object.
- bool ownsObject (const data_type *theObject)
    Determine if an object is owned by the allocator...
- void reset ()
    Delete all instance objects from allocator.
- size_type getBlockCount () const
    Get the number of ArenaBlocks currently allocated.
- size_type getBlockSize () const
    Get size of an ArenaBlock, that is, the number of objects in each block.
- MemoryManagerType & getMemoryManager ()
    Get a reference to the MemoryManagerType instance for this instance.
- const MemoryManagerType & getMemoryManager () const
    Get a reference to the MemoryManagerType instance for this instance.

## Member Typedef Documentation

typedef ArenaAllocator<data_type> XalanDOMStringAllocator::ArenaAllocatorType

typedef XalanDOMString XalanDOMStringAllocator::data_type

typedef data_type::size_type XalanDOMStringAllocator::data_type_size_type

typedef ArenaAllocatorType::size_type XalanDOMStringAllocator::size_type

## Member Enumeration Documentation

anonymous enum

Enumeration values:

  eDefaultBlockSize |

## Constructor & Destructor Documentation

XalanDOMStringAllocator::XalanDOMStringAllocator | ( | MemoryManagerType & | theManager,
|  | size_type | theBlockCount
| ) |

Construct an instance that will allocate in blocks of the specified size.

Parameters:

  theBlockSize | The block size.

XalanDOMStringAllocator::~XalanDOMStringAllocator | ( |  | ) |

## Member Function Documentation

data_type* XalanDOMStringAllocator::create | ( | data_type_size_type | theCount,
|  | XalanDOMChar | theChar
| ) |

Create a XalanDOMString object.

Parameters:

  theCount | the size of the string
  theChar | the character used to initialize the string

Returns:
  pointer to the new instance

data_type* XalanDOMStringAllocator::create | ( | const XalanDOMChar * | theString,
|  | data_type_size_type | theCount = data_type_size_type(data_type::npos)
| ) |

Create a XalanDOMString object.

Parameters:

  theString | A pointer to a wide character string
  theCount | The number of characters in the string, or npos if the string is null-terminated.

Returns:
  pointer to the new instance

data_type* XalanDOMStringAllocator::create | ( | const data_type & | theSource,
|  | data_type_size_type | theStartPosition = 0,
|  | data_type_size_type | theCount = data_type_size_type(data_type::npos)
| ) |

Copy constructor.

Parameters:

  theSource | The source string for the copy
  theStartPosition | The position to start in the source string.
  theCount | The number of characters to copy from the source string.

Returns:
  pointer to the new instance

data_type* XalanDOMStringAllocator::create | ( | const char * | theString,
|  | data_type_size_type | theCount = data_type_size_type(data_type::npos)
| ) |

Create a XalanDOMString object.

Parameters:

  theString | A pointer to a character string
  theCount | The number of characters in the string, or npos if the string is null-terminated.

Returns:
  pointer to the new instance

data_type* XalanDOMStringAllocator::create | ( |  | ) |

Create a XalanDOMString object.

Returns:
  pointer to the new instance

size_type XalanDOMStringAllocator::getBlockCount | ( |  | ) | const

Get the number of ArenaBlocks currently allocated.

Returns:
  The number of blocks.

size_type XalanDOMStringAllocator::getBlockSize | ( |  | ) | const

Get size of an ArenaBlock, that is, the number of objects in each block.

Returns:
  The size of the block

const MemoryManagerType& XalanDOMStringAllocator::getMemoryManager | ( |  | ) | const

Get a reference to the MemoryManagerType instance for this instance.

Returns:
  A reference to the MemoryManagerType instance.

MemoryManagerType& XalanDOMStringAllocator::getMemoryManager | ( |  | ) |

Get a reference to the MemoryManagerType instance for this instance.

Returns:
  A reference to the MemoryManagerType instance.

bool XalanDOMStringAllocator::ownsObject | ( | const data_type * | theObject | ) |

| Determine if an object is owned by the allocator...

void XalanDOMStringAllocator::reset | ( |  | ) |

| Delete all instance objects from allocator.

The documentation for this class was generated from the following file:

- XalanDOMStringAllocator.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.9 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.